
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef PROCESS_DB_H
#define PROCESS_DB_H
#include <sys/types.h>
#include <unistd.h>
#include "initng_service_cache.h"

#define MAX_BUFFER 1024                     /* This is the maximum size of buffer in process_h */

typedef enum
{
    T_UKNOWN = 0,
    T_START = 1,
    T_STOP = 2,
    T_PRE = 3,
    T_POST = 4
} e_pt;

/* struct containing data on an running process */
typedef struct
{
    e_pt pt;
    pid_t pid;                  /* pid of process */
    int r_code;
    int out_pipe[2];              /* pipes of process */
    char *buffer;               /* stdout buffer */
    int buffer_pos;             /* Our current position in the buffer */
} process_h;


/* functions for creating and freeing a process struct */
process_h *process_db_new(e_pt type);
void process_db_free(process_h * free_this);
#endif
